#!/usr/bin/env python

import numpy as np
from matplotlib import pyplot as plt

POINTS = 10000	# Number of samples
RADIUS = 5 	# Degrees, field of view to sample

wl = 0.18	# Metres, wavelength
d1 = 100.0	# Metres, dish diameter 1
d2 = 25.0	# Metres, dish diameter 2

N = 0.8 	# Constant
r = np.radians(RADIUS)
ang = np.arange(0, r, r / POINTS)
plt.plot(60 * np.degrees(ang), np.sinc(N * ang * d1 / wl) * np.sinc(N * ang * d2 / wl))
plt.show()
