#!/usr/bin/env python

from pyrap.tables import table
import sys
import math

import warnings
warnings.filterwarnings('ignore', category=DeprecationWarning)

if len(sys.argv) != 2 and len(sys.argv) != 3:
	print >> sys.stderr, 'Usage: %s MS [wavelength]' % sys.argv[0]
	sys.exit()

ms = table(sys.argv[1], ack=False)
max_u, max_v, max_w = 0, 0, 0
uvw = ms.getcol('UVW')
u,v,w = uvw[:,0].max(), uvw[:,1].max(), uvw[:,2].max()
print 'Max U, V, W:', u,v,w
print 'Max UV: %0.2fm' % ((u**2 + v**2) ** 0.5)
try:
	wl = float(sys.argv[2])
	print 'Max UV: %0.2f lambda' % ((u**2 + v**2) ** 0.5 / wl)
except:
	pass
