#!/usr/bin/env ParselTongue
#
# Tool to convert AIPS SN tables into Measurement Set Calibration tables
# Stephen Bourke, JIVE
# Nov, 2010

import AIPS
from AIPSData import AIPSUVData, AIPSCat
from pyrap.tables import table
from pyrap.quanta import quantity
import math
import sys
import shutil
import datetime
import calendar
import numpy
import os.path

mod_jul_day = quantity(40587.0, 'd')
mod_jul_day.convert(quantity(1.0, 's')) # Modified Julien day

if len(sys.argv) != 5:
	print >> sys.stderr, 'Usage: %s <userno> <disk> <cno> <ms>' % sys.argv[0]
	sys.exit()
AIPS.userno, disk, cno = [int(i) for i in sys.argv[1:4]]
ms_name = sys.argv[4]

ds = [i for i in AIPSCat()[disk] if i['cno'] == cno][0]
uv = AIPSUVData(ds['name'], ds['klass'], disk, ds['seq'])
obs_date = datetime.datetime(*[int(i) for i in uv.header.date_obs.split('-')])

print uv, '->', ms_name

aips_ant = uv.table('AN', 1)
ms_ant = table(ms_name + '/ANTENNA', ack=False)

for aips_row in aips_ant:
	for ms_row in ms_ant:
		if aips_row['anname'].strip() == ms_row['STATION']:
			print aips_row['nosta'], '->', ms_row['NAME']
			break
