#!/usr/bin/env ParselTongue

import AIPS
from AIPSData import AIPSUVData
from pyrap.tables import table
import math
import numpy

AIPS.userno = 5422

uv = AIPSUVData('20030703', 'LINE', 1,1)
bp = uv.table('BP', 1)
bcal = table('../pb1.bcal', ack=False, readonly=False)

ant_nums = []
ant = table('../AG650.MS/ANTENNA', ack=False)
for row in ant:
	ant_nums.append(int(row['NAME'][-2:]))

for i in range(len(bcal)):
	b = bcal[i]['GAIN']
	print 'casa', i, '->', 'aips', ant_nums[i]
	b[:,0] = numpy.array(bp[ant_nums[i] - 1].real_1) + 1j * numpy.array(bp[ant_nums[i] - 1].imag_1)
	b[:,1] = numpy.array(bp[ant_nums[i] - 1].real_2) + 1j * numpy.array(bp[ant_nums[i] - 1].imag_2)
	bcal[i] = {'GAIN': b}
	bcal[i].update()
bcal.close()
