#!/usr/bin/env ParselTongue

import AIPS
from AIPSData import AIPSUVData, AIPSCat
from pyrap.tables import table
import sys

if len(sys.argv) != 6:
	print >> sys.stderr, 'Usage: %s <userno> <disk> <cno> <ms> <antfile>' % sys.argv[0]
	sys.exit()
AIPS.userno, disk, cno = [int(i) for i in sys.argv[1:4]]
ms_name, antfile = sys.argv[4:6]

ds = [i for i in AIPSCat()[disk] if i['cno'] == cno][0]
uv = AIPSUVData(ds['name'], ds['klass'], disk, ds['seq'])

an = uv.table('AN', 0)
ant = table(ms_name + '/ANTENNA', ack=False)

def get_aips_ant_name(antno):
	for line in an:
		if line['nosta'] == antno:
			return line['anname']
	return None

inf = open(antfile)
for line in inf:
	aips_ant_no = int(line.split()[0].strip())
	ms_ant_id = int(line.split()[1].strip())
	print aips_ant_no, get_aips_ant_name(aips_ant_no), '->', \
		ms_ant_id, ant[ms_ant_id]['NAME'], ant[ms_ant_id]['STATION']
