from taskinit import tbtool
from numpy import array

cal_info = {'readme': '', 'subType': '', 'type': 'Calibration'}

cal_main_desc = {
 'ANTENNA1': {'comment': '',
              'dataManagerGroup': 'StandardStMan',
              'dataManagerType': 'StandardStMan',
              'maxlen': 0,
              'option': 5,
              'valueType': 'integer'},
 'ARRAY_ID': {'comment': '',
              'dataManagerGroup': 'StandardStMan',
              'dataManagerType': 'StandardStMan',
              'maxlen': 0,
              'option': 5,
              'valueType': 'integer'},
 'CALIBRATION_GROUP': {'comment': '',
                       'dataManagerGroup': 'StandardStMan',
                       'dataManagerType': 'StandardStMan',
                       'maxlen': 0,
                       'option': 5,
                       'valueType': 'integer'},
 'CAL_DESC_ID': {'comment': '',
                 'dataManagerGroup': 'StandardStMan',
                 'dataManagerType': 'StandardStMan',
                 'maxlen': 0,
                 'option': 5,
                 'valueType': 'integer'},
 'CAL_HISTORY_ID': {'comment': '',
                    'dataManagerGroup': 'StandardStMan',
                    'dataManagerType': 'StandardStMan',
                    'maxlen': 0,
                    'option': 5,
                    'valueType': 'integer'},
 'FEED1': {'comment': '',
           'dataManagerGroup': 'StandardStMan',
           'dataManagerType': 'StandardStMan',
           'maxlen': 0,
           'option': 5,
           'valueType': 'integer'},
 'FIELD_CODE': {'comment': '',
                'dataManagerGroup': 'StandardStMan',
                'dataManagerType': 'StandardStMan',
                'maxlen': 0,
                'option': 5,
                'valueType': 'string'},
 'FIELD_ID': {'comment': '',
              'dataManagerGroup': 'StandardStMan',
              'dataManagerType': 'StandardStMan',
              'maxlen': 0,
              'option': 5,
              'valueType': 'integer'},
 'FIELD_NAME': {'comment': '',
                'dataManagerGroup': 'StandardStMan',
                'dataManagerType': 'StandardStMan',
                'maxlen': 0,
                'option': 5,
                'valueType': 'string'},
 'FIT': {'comment': '',
         'dataManagerGroup': 'StandardStMan',
         'dataManagerType': 'StandardStMan',
         'maxlen': 0,
         'ndim': -1,
         'option': 0,
         'valueType': 'float'},
 'FIT_WEIGHT': {'comment': '',
                'dataManagerGroup': 'StandardStMan',
                'dataManagerType': 'StandardStMan',
                'maxlen': 0,
                'ndim': -1,
                'option': 0,
                'valueType': 'float'},
 'FLAG': {'comment': '',
          'dataManagerGroup': 'StandardStMan',
          'dataManagerType': 'StandardStMan',
          'maxlen': 0,
          'ndim': -1,
          'option': 0,
          'valueType': 'boolean'},
 'FREQ_GROUP': {'comment': '',
                'dataManagerGroup': 'StandardStMan',
                'dataManagerType': 'StandardStMan',
                'maxlen': 0,
                'option': 5,
                'valueType': 'integer'},
 'FREQ_GROUP_NAME': {'comment': '',
                     'dataManagerGroup': 'StandardStMan',
                     'dataManagerType': 'StandardStMan',
                     'maxlen': 0,
                     'option': 5,
                     'valueType': 'string'},
 'GAIN': {'comment': '',
          'dataManagerGroup': 'StandardStMan',
          'dataManagerType': 'StandardStMan',
          'maxlen': 0,
          'ndim': -1,
          'option': 0,
          'valueType': 'complex'},
 'INTERVAL': {'comment': '',
              'dataManagerGroup': 'StandardStMan',
              'dataManagerType': 'StandardStMan',
              'maxlen': 0,
              'option': 5,
              'valueType': 'double'},
 'MEAS_DIR_REF': {'comment': '',
                  'dataManagerGroup': 'StandardStMan',
                  'dataManagerType': 'StandardStMan',
                  'maxlen': 0,
                  'option': 5,
                  'valueType': 'integer'},
 'MEAS_FREQ_REF': {'comment': '',
                   'dataManagerGroup': 'StandardStMan',
                   'dataManagerType': 'StandardStMan',
                   'maxlen': 0,
                   'option': 5,
                   'valueType': 'integer'},
 'OBSERVATION_ID': {'comment': '',
                    'dataManagerGroup': 'StandardStMan',
                    'dataManagerType': 'StandardStMan',
                    'maxlen': 0,
                    'option': 5,
                    'valueType': 'integer'},
 'PHASE_ID': {'comment': '',
              'dataManagerGroup': 'StandardStMan',
              'dataManagerType': 'StandardStMan',
              'maxlen': 0,
              'option': 5,
              'valueType': 'integer'},
 'PROCESSOR_ID': {'comment': '',
                  'dataManagerGroup': 'StandardStMan',
                  'dataManagerType': 'StandardStMan',
                  'maxlen': 0,
                  'option': 5,
                  'valueType': 'integer'},
 'PULSAR_BIN': {'comment': '',
                'dataManagerGroup': 'StandardStMan',
                'dataManagerType': 'StandardStMan',
                'maxlen': 0,
                'option': 5,
                'valueType': 'integer'},
 'PULSAR_GATE_ID': {'comment': '',
                    'dataManagerGroup': 'StandardStMan',
                    'dataManagerType': 'StandardStMan',
                    'maxlen': 0,
                    'option': 5,
                    'valueType': 'integer'},
 'REF_ANT': {'comment': '',
             'dataManagerGroup': 'StandardStMan',
             'dataManagerType': 'StandardStMan',
             'maxlen': 0,
             'ndim': -1,
             'option': 0,
             'valueType': 'integer'},
 'REF_DIRECTION': {'comment': '',
                   'dataManagerGroup': 'StandardStMan',
                   'dataManagerType': 'StandardStMan',
                   'maxlen': 0,
                   'ndim': -1,
                   'option': 0,
                   'valueType': 'double'},
 'REF_FEED': {'comment': '',
              'dataManagerGroup': 'StandardStMan',
              'dataManagerType': 'StandardStMan',
              'maxlen': 0,
              'ndim': -1,
              'option': 0,
              'valueType': 'integer'},
 'REF_FREQUENCY': {'comment': '',
                   'dataManagerGroup': 'StandardStMan',
                   'dataManagerType': 'StandardStMan',
                   'maxlen': 0,
                   'ndim': -1,
                   'option': 0,
                   'valueType': 'double'},
 'REF_RECEPTOR': {'comment': '',
                  'dataManagerGroup': 'StandardStMan',
                  'dataManagerType': 'StandardStMan',
                  'maxlen': 0,
                  'ndim': -1,
                  'option': 0,
                  'valueType': 'integer'},
 'SCAN_NUMBER': {'comment': '',
                 'dataManagerGroup': 'StandardStMan',
                 'dataManagerType': 'StandardStMan',
                 'maxlen': 0,
                 'option': 5,
                 'valueType': 'integer'},
 'SNR': {'comment': '',
         'dataManagerGroup': 'StandardStMan',
         'dataManagerType': 'StandardStMan',
         'maxlen': 0,
         'ndim': -1,
         'option': 0,
         'valueType': 'float'},
 'SOLUTION_OK': {'comment': '',
                 'dataManagerGroup': 'StandardStMan',
                 'dataManagerType': 'StandardStMan',
                 'maxlen': 0,
                 'ndim': -1,
                 'option': 0,
                 'valueType': 'boolean'},
 'SOURCE_CODE': {'comment': '',
                 'dataManagerGroup': 'StandardStMan',
                 'dataManagerType': 'StandardStMan',
                 'maxlen': 0,
                 'option': 5,
                 'valueType': 'string'},
 'SOURCE_NAME': {'comment': '',
                 'dataManagerGroup': 'StandardStMan',
                 'dataManagerType': 'StandardStMan',
                 'maxlen': 0,
                 'option': 5,
                 'valueType': 'string'},
 'STATE_ID': {'comment': '',
              'dataManagerGroup': 'StandardStMan',
              'dataManagerType': 'StandardStMan',
              'maxlen': 0,
              'option': 5,
              'valueType': 'integer'},
 'TIME': {'comment': '',
          'dataManagerGroup': 'StandardStMan',
          'dataManagerType': 'StandardStMan',
          'maxlen': 0,
          'option': 5,
          'valueType': 'double'},
 'TIME_EXTRA_PREC': {'comment': '',
                     'dataManagerGroup': 'StandardStMan',
                     'dataManagerType': 'StandardStMan',
                     'maxlen': 0,
                     'option': 5,
                     'valueType': 'double'},
 'TOTAL_FIT': {'comment': '',
               'dataManagerGroup': 'StandardStMan',
               'dataManagerType': 'StandardStMan',
               'maxlen': 0,
               'option': 5,
               'valueType': 'float'},
 'TOTAL_FIT_WEIGHT': {'comment': '',
                      'dataManagerGroup': 'StandardStMan',
                      'dataManagerType': 'StandardStMan',
                      'maxlen': 0,
                      'option': 5,
                      'valueType': 'float'},
 'TOTAL_SOLUTION_OK': {'comment': '',
                       'dataManagerGroup': 'StandardStMan',
                       'dataManagerType': 'StandardStMan',
                       'maxlen': 0,
                       'option': 5,
                       'valueType': 'boolean'},
 '_define_hypercolumn_': {}}


cal_desc_desc = {
 'CHAN_FREQ': {'comment': '',
               'dataManagerGroup': 'StandardStMan',
               'dataManagerType': 'StandardStMan',
               'maxlen': 0,
               'ndim': -1,
               'option': 0,
               'valueType': 'double'},
 'CHAN_RANGE': {'comment': '',
                'dataManagerGroup': 'StandardStMan',
                'dataManagerType': 'StandardStMan',
                'maxlen': 0,
                'ndim': -1,
                'option': 0,
                'valueType': 'integer'},
 'CHAN_WIDTH': {'comment': '',
                'dataManagerGroup': 'StandardStMan',
                'dataManagerType': 'StandardStMan',
                'maxlen': 0,
                'ndim': -1,
                'option': 0,
                'valueType': 'double'},
 'JONES_TYPE': {'comment': '',
                'dataManagerGroup': 'StandardStMan',
                'dataManagerType': 'StandardStMan',
                'maxlen': 0,
                'option': 5,
                'valueType': 'string'},
 'MEAS_FREQ_REF': {'comment': '',
                   'dataManagerGroup': 'StandardStMan',
                   'dataManagerType': 'StandardStMan',
                   'maxlen': 0,
                   'option': 5,
                   'valueType': 'integer'},
 'MS_NAME': {'comment': '',
             'dataManagerGroup': 'StandardStMan',
             'dataManagerType': 'StandardStMan',
             'maxlen': 0,
             'option': 5,
             'valueType': 'string'},
 'NUM_CHAN': {'comment': '',
              'dataManagerGroup': 'StandardStMan',
              'dataManagerType': 'StandardStMan',
              'maxlen': 0,
              'ndim': -1,
              'option': 0,
              'valueType': 'integer'},
 'NUM_RECEPTORS': {'comment': '',
                   'dataManagerGroup': 'StandardStMan',
                   'dataManagerType': 'StandardStMan',
                   'maxlen': 0,
                   'option': 5,
                   'valueType': 'integer'},
 'NUM_SPW': {'comment': '',
             'dataManagerGroup': 'StandardStMan',
             'dataManagerType': 'StandardStMan',
             'maxlen': 0,
             'option': 5,
             'valueType': 'integer'},
 'N_JONES': {'comment': '',
             'dataManagerGroup': 'StandardStMan',
             'dataManagerType': 'StandardStMan',
             'maxlen': 0,
             'option': 5,
             'valueType': 'integer'},
 'POLARIZATION_TYPE': {'comment': '',
                       'dataManagerGroup': 'StandardStMan',
                       'dataManagerType': 'StandardStMan',
                       'maxlen': 0,
                       'ndim': -1,
                       'option': 0,
                       'valueType': 'string'},
 'SPECTRAL_WINDOW_ID': {'comment': '',
                        'dataManagerGroup': 'StandardStMan',
                        'dataManagerType': 'StandardStMan',
                        'maxlen': 0,
                        'ndim': -1,
                        'option': 0,
                        'valueType': 'integer'},
 '_define_hypercolumn_': {}}

cal_history_desc = {
 'CAL_NOTES': {'comment': '',
               'dataManagerGroup': 'StandardStMan',
               'dataManagerType': 'StandardStMan',
               'maxlen': 0,
               'option': 5,
               'valueType': 'string'},
 'CAL_PARMS': {'comment': '',
               'dataManagerGroup': 'StandardStMan',
               'dataManagerType': 'StandardStMan',
               'maxlen': 0,
               'option': 5,
               'valueType': 'string'},
 'CAL_SELECT': {'comment': '',
                'dataManagerGroup': 'StandardStMan',
                'dataManagerType': 'StandardStMan',
                'maxlen': 0,
                'option': 5,
                'valueType': 'string'},
 'CAL_TABLES': {'comment': '',
                'dataManagerGroup': 'StandardStMan',
                'dataManagerType': 'StandardStMan',
                'maxlen': 0,
                'option': 5,
                'valueType': 'string'},
 '_define_hypercolumn_': {}}

cal_main_colkeywords = {
 'TIME': {'QuantumUnits': array(['s'], dtype='|S2'),
          'MEASINFO': {'type': 'epoch', 'Ref': 'UTC'}},
 'TIME_EXTRA_PREC': {'QuantumUnits': array(['s'], dtype='|S2')},
 'INTERVAL': {'QuantumUnits': array(['s'], dtype='|S2')},
 'REF_FREQUENCY': {'QuantumUnits': array(['Hz'], dtype='|S3'), 
                   'MEASINFO': {'TabRefTypes': array(['REST', 'LSRK', 'LSRD', 'BARY', 'GEO', 'TOPO', 'GALACTO', 'LGROUP', 'CMB'], dtype='|S8'),
                                'type': 'frequency',
                                'TabRefCodes': array([0, 1, 2, 3, 4, 5, 6, 7, 8], dtype='uint'),
                                'VarRefCol': 'MEAS_FREQ_REF'}},
 'REF_DIRECTION': {'QuantumUnits': array(['rad', 'rad'], dtype='|S4'),
                   'MEASINFO': {'TabRefTypes': array(['J2000', 'JMEAN', 'JTRUE', 'APP', 'B1950', 'B1950_VLA', 'BMEAN', 'BTRUE', 'GALACTIC', 'HADEC', 'AZEL', 'AZELSW', 'AZELNE', 'AZELGEO', 'AZELSWGEO', 'AZELNEGEO', 'JNAT', 'ECLIPTIC', 'MECLIPTIC', 'TECLIPTIC', 'SUPERGAL', 'ITRF', 'TOPO', 'ICRS', 'MERCURY', 'VENUS', 'MARS', 'JUPITER', 'SATURN', 'URANUS', 'NEPTUNE', 'PLUTO', 'SUN', 'MOON', 'COMET'], dtype='|S10'),
                                'type': 'direction',
                                'TabRefCodes': array([ 0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 10, 12, 13, 12, 14, 15, 16, 17, 18, 19, 20, 21, 32, 33, 34, 35, 36, 37, 38, 39, 40, 41, 42], dtype='uint'),
                                'VarRefCol': 'MEAS_DIR_REF'}}}

cal_desc_colkeywords = {
 'CHAN_FREQ': {'QuantumUnits': array(['Hz'], dtype='|S3'),
               'MEASINFO': {'TabRefTypes': array(['REST', 'LSRK', 'LSRD', 'BARY', 'GEO', 'TOPO', 'GALACTO', 'LGROUP', 'CMB'], dtype='|S8'),
                            'type': 'frequency',
                            'TabRefCodes': array([0, 1, 2, 3, 4, 5, 6, 7, 8], dtype='uint'),
                            'VarRefCol': 'MEAS_FREQ_REF'}},
 'CHAN_WIDTH': {'QuantumUnits': array(['Hz'], dtype='|S3')}}

def create_cal(cal_name, cal_type):
	cal_main = tbtool.create()
	cal_main.create(cal_name, cal_main_desc)
	info = cal_info
	info['subType'] = cal_type + ' Jones'
	cal_main.putinfo(info)
	for col, value in cal_main_colkeywords.items():
		cal_main.putcolkeywords(col, value)
	cal_desc = tbtool.create()
	cal_desc.create(cal_name + '/CAL_DESC', cal_desc_desc)
	for col, value in cal_desc_colkeywords.items():
		cal_desc.putcolkeywords(col, value)
	cal_desc.close()
	cal_history = tbtool.create()
	cal_history.create(cal_name + '/CAL_HISTORY', cal_history_desc)
	cal_history.close()
	cal_main.putkeyword('CAL_DESC_ID', 0)
	cal_main.putkeyword('CAL_HISTORY_ID', 0)
	cal_main.putkeyword('CAL_DESC', 'Table: %s/CAL_DESC' % cal_name)
	cal_main.putkeyword('CAL_HISTORY', 'Table: %s/CAL_HISTORY' % cal_name)
	return cal_main
