#!/usr/bin/env python
#
from taskinit import tbtool, casalog, qa

def table(tbname, readonly=True):
	tbl = tbtool.create()
	tbl.open(tbname, nomodify=readonly)
	return tbl

def nants(msname):
	return table(msname + '/ANTENNA').nrows()

def get_field_id(msname, value):
	field_tbl = table(msname + '/FIELD')
	fld_names = field_tbl.getcol('NAME')
	try:
		field_id = int(value)
		if field_id >= field_tbl.nrows():
			raise ValueError
	except ValueError:
		try:
			field_id = list(fld_names).index(value)
		except ValueError:
			field_tbl.close()
			raise ValueError, "Field '%s' not found found." % str(value)
	field_tbl.close()
	return field_id

def scan_list(msname, field):
	return table(msname).query('FIELD_ID==%d' % get_field_id(msname, field), columns='UNIQUE SCAN_NUMBER').getcol('SCAN_NUMBER')
