#
# This file was generated using xslt from its XML file
#
# Copyright 2008, Associated Universities Inc., Washington DC
#
import sys
import os
import casac
import string
import time
import inspect
import gc
import numpy
from odict import odict
from taskmanager import tm
from task_importaipscal2 import importaipscal2
from task_importaipscal2 import casalog

class importaipscal2_cli_:
    __name__ = "importaipscal2"
    __async__ = {}
    rkey = None
    i_am_a_casapy_task = None
    # The existence of the i_am_a_casapy_task attribute allows help()
    # (and other) to treat casapy tasks as a special case.

    def __init__(self) :
       self.__bases__ = (importaipscal2_cli_,)
       self.__doc__ = self.__call__.__doc__

       self.parameters={'vis':None, 'caltable':None, 'userno':None, 'indisk':None, 'cno':None, 'inver':None, 'mode':None, 'antfile':None,  'async':None}


    def result(self, key=None):
	    #### here we will scan the task-ids in __async__
	    #### and add any that have completed...
	    if key is not None and self.__async__.has_key(key) and self.__async__[key] is not None:
	       ret = tm.retrieve(self.__async__[key])
	       if ret['state'] == "done" :
	          self.__async__[key] = None
	       elif ret['state'] == 'crashed' :
		  self.__async__[key] = None
	       return ret
	    return None


    def __call__(self, vis=None, caltable=None, userno=None, indisk=None, cno=None, inver=None, mode=None, antfile=None,  async=None):

        """Convert AIPS calibration tables to MS cal tables.

	vis -- Name of input visibility file
		default: none; example: vis='ngc5921.ms'

        """
	if not hasattr(self, "__globals__") or self.__globals__ == None :
           self.__globals__=sys._getframe(len(inspect.stack())-1).f_globals
        self.__globals__['__last_task'] = 'importaipscal2'
        self.__globals__['taskname'] = 'importaipscal2'
        ###
        self.__globals__['update_params'](func=self.__globals__['taskname'],printtext=False,ipython_globals=self.__globals__)
        ###
        ###
        #Handle globals or user over-ride of arguments
        #
	function_signature_defaults=dict(zip(self.__call__.func_code.co_varnames,self.__call__.func_defaults))
	useLocalDefaults = False

        for item in function_signature_defaults.iteritems():
                key,val = item
                keyVal = eval(key)
                if (keyVal == None):
                        #user hasn't set it - use global/default
                        pass
                else:
                        #user has set it - use over-ride
			if (key != 'self') :
			   useLocalDefaults = True

	myparams = {}
	if useLocalDefaults :
	   for item in function_signature_defaults.iteritems():
	       key,val = item
	       keyVal = eval(key)
	       exec('myparams[key] = keyVal')
	       self.parameters[key] = keyVal
	       if (keyVal == None):
	           exec('myparams[key] = '+ key + ' = self.itsdefault(key)')
		   keyVal = eval(key)
		   if(type(keyVal) == dict) :
                      if len(keyVal) > 0 :
		         exec('myparams[key] = ' + key + ' = keyVal[len(keyVal)-1][\'value\']')
		      else :
		         exec('myparams[key] = ' + key + ' = {}')

	else :
            async = self.parameters['async']
            myparams['vis'] = vis = self.parameters['vis']
            myparams['caltable'] = caltable = self.parameters['caltable']
            myparams['userno'] = userno = self.parameters['userno']
            myparams['indisk'] = indisk = self.parameters['indisk']
            myparams['cno'] = cno = self.parameters['cno']
            myparams['inver'] = inver = self.parameters['inver']
            myparams['mode'] = mode = self.parameters['mode']
            myparams['antfile'] = antfile = self.parameters['antfile']


	result = None

#
#    The following is work around to avoid a bug with current python translation
#
        mytmp = {}

        mytmp['vis'] = vis
        mytmp['caltable'] = caltable
        mytmp['userno'] = userno
        mytmp['indisk'] = indisk
        mytmp['cno'] = cno
        mytmp['inver'] = inver
        mytmp['mode'] = mode
        mytmp['antfile'] = antfile
        pathname="file:///home/stephen/casa_tasks/"
        trec = casac.cu.torecord(pathname+'importaipscal2.xml')

        casalog.origin('importaipscal2')
        if not trec.has_key('importaipscal2') or not casac.cu.verify(mytmp, trec['importaipscal2']) :
	    return False

	try :
          saveinputs = self.__globals__['saveinputs']
          saveinputs('importaipscal2', 'importaipscal2.last', myparams, self.__globals__)
          if async :
	    count = 0
	    keybase =  time.strftime("%y%m%d.%H%M%S")
	    key = keybase + "_" + str(count)
	    while self.__async__.has_key(key) :
	       count += 1
	       key = keybase + "_" + str(count)
            result = tm.execute('importaipscal2', vis, caltable, userno, indisk, cno, inver, mode, antfile)
	    print "Use: "
	    print "      tm.retrieve(return_value) # to retrieve the status"
	    print 
	    self.rkey = key
	    self.__async__[key] = result
          else :
              tname = 'importaipscal2'
              spaces = ' '*(18-len(tname))
              casalog.post('')
              casalog.post('##########################################')
              casalog.post('##### Begin Task: ' + tname + spaces + ' #####')
              casalog.post('')
              result = importaipscal2(vis, caltable, userno, indisk, cno, inver, mode, antfile)
              casalog.post('')
              casalog.post('##### End Task: ' + tname + '  ' + spaces + ' #####')
              casalog.post('##########################################')

	except Exception, instance:
          if(self.__globals__.has_key('__rethrow_casa_exceptions') and self.__globals__['__rethrow_casa_exceptions']) :
             raise
          else :
             print '**** Error **** ',instance

        gc.collect()
        return result
#
#
#
    def paramgui(self, useGlobals=True, ipython_globals=None):
        """
        Opens a parameter GUI for this task.  If useGlobals is true, then any relevant global parameter settings are used.
        """
        import paramgui
	if not hasattr(self, "__globals__") or self.__globals__ == None :
           self.__globals__=sys._getframe(len(inspect.stack())-1).f_globals

        if useGlobals:
	    if ipython_globals == None:
                myf=self.__globals__
            else:
                myf=ipython_globals

            paramgui.setGlobals(myf)
        else:
            paramgui.setGlobals({})

        paramgui.runTask('importaipscal2', myf['_ip'])
        paramgui.setGlobals({})

#
#
#
    def defaults(self, param=None, ipython_globals=None, paramvalue=None, subparam=None):
	if not hasattr(self, "__globals__") or self.__globals__ == None :
           self.__globals__=sys._getframe(len(inspect.stack())-1).f_globals
        if ipython_globals == None:
            myf=self.__globals__
        else:
            myf=ipython_globals

        a = odict()
        a['vis']  = ''
        a['caltable']  = ''
        a['userno']  = 0
        a['indisk']  = 0
        a['cno']  = 0
        a['inver']  = 0
        a['mode']  = 'CL'
        a['antfile']  = ''

        a['async']=False

### This function sets the default values but also will return the list of
### parameters or the default value of a given parameter
        if(param == None):
                myf['__set_default_parameters'](a)
        elif(param == 'paramkeys'):
                return a.keys()
        else:
            if(paramvalue==None and subparam==None):
               if(a.has_key(param)):
                  return a[param]
               else:
                  return self.itsdefault(param)
            else:
               retval=a[param]
               if(type(a[param])==dict):
                  for k in range(len(a[param])):
                     valornotval='value'
                     if(a[param][k].has_key('notvalue')):
                        valornotval='notvalue'
                     if((a[param][k][valornotval])==paramvalue):
                        retval=a[param][k].copy()
                        retval.pop(valornotval)
                        if(subparam != None):
                           if(retval.has_key(subparam)):
                              retval=retval[subparam]
                           else:
                              retval=self.itsdefault(subparam)
		     else:
                        retval=self.itsdefault(subparam)
               return retval


#
#
    def check_params(self, param=None, value=None, ipython_globals=None):
      if ipython_globals == None:
          myf=self.__globals__
      else:
          myf=ipython_globals

      if str(type(value)) != "<type 'instance'>" :
         value = myf['cu'].expandparam(param, value)
         if(type(value) == numpy.ndarray) :
            myf[param] = value.tolist()
         else :
            myf[param] = value
         value = myf['cu'].verifyparam({param:value})
      return value
#
#
    def description(self, key='importaipscal2', subkey=None):
        desc={'importaipscal2': 'Convert AIPS calibration tables to MS cal tables.',
               'vis': 'name of input visibility file',
               'caltable': 'Basename of output table(s)',
               'userno': 'AIPS userno',
               'indisk': 'AIPS disk number',
               'cno': 'AIPS catalog number',
               'inver': 'AIPS table version',
               'mode': 'Calibration mode',
               'antfile': 'Text file providing AIPS to Casa antenna mapping',

               'async': 'If true the taskname must be started using importaipscal2(...)'
              }

        if(desc.has_key(key)) :
           return desc[key]

    def itsdefault(self, paramname) :
        a = {}
        a['vis']  = ''
        a['caltable']  = ''
        a['userno']  = 0
        a['indisk']  = 0
        a['cno']  = 0
        a['inver']  = 0
        a['mode']  = 'CL'
        a['antfile']  = ''

        #a = sys._getframe(len(inspect.stack())-1).f_globals

        if a.has_key(paramname) :
	      return a[paramname]
importaipscal2_cli = importaipscal2_cli_()
