#
# This file was generated using xslt from its XML file
#
# Copyright 2009, Associated Universities Inc., Washington DC
#
import sys
import os
import casac
import string
from taskinit import casalog
#from taskmanager import tm
import task_shift
def shift(vis='', field='', shiftval=['0.0arcsec', '0.0arcsec'], nrows=1024):

        """Shift a Measurement Set to different location.

	vis -- Name of input visibility file
		default: none; example: vis='ngc5921.ms'
	field -- Select fields in mosaic. Use field id(s) or field name(s).
		['go listobs' to obtain the list id's or names]
		default: ''=all fields
		If field string is a non-negative integer, it is assumed to
		be a field index otherwise, it is assumed to be a
		field name
		field='0~2'; field ids 0,1,2
		field='0,4,5~7'; field ids 0,4,5,6,7
		field='3C286,3C295'; field named 3C286 and 3C295
		field = '3,4C*'; field id 3, all names starting with 4C
	shift -- ra, dec shift
		default= '0.0arcsec';
		example: shiftval=['0.5arcsec,'0.5arcsec'] or
		shiftval=['1arcmin', '1arcmin']
		shiftval = '1arcsec' is equivalent to ['1arcsec','1arcsec']
	nrows -- Select the number of rows to process in each loop.
		Controls the number of data rows to read into RAM at a time.
		If the value is too large the process will fail.
		default = 1024

        """
        if type(shiftval)==float: shiftval=[shiftval]

#
#    The following is work around to avoid a bug with current python translation
#
        mytmp = {}

        mytmp['vis'] = vis
        mytmp['field'] = field
        if type(shiftval) == str :
           mytmp['shiftval'] = casac.qa.quantity(shiftval)
        else :
           mytmp['shiftval'] = shiftval
        mytmp['nrows'] = nrows
        pathname="file:///home/stephen/casa_tasks/"
        trec = casac.cu.torecord(pathname+'shift.xml')

        casalog.origin('shift')
        if trec.has_key('shift') and casac.cu.verify(mytmp, trec['shift']) :
	    result = task_shift.shift(vis, field, shiftval, nrows)

	else :
	  result = False
        return result
