#
# This file was generated using xslt from its XML file
#
# Copyright 2008, Associated Universities Inc., Washington DC
#
import sys
import os
import casac
import string
import time
import inspect
import gc
import numpy
from odict import odict
from taskmanager import tm
from task_shift import shift
from task_shift import casalog

class shift_cli_:
    __name__ = "shift"
    __async__ = {}
    rkey = None
    i_am_a_casapy_task = None
    # The existence of the i_am_a_casapy_task attribute allows help()
    # (and other) to treat casapy tasks as a special case.

    def __init__(self) :
       self.__bases__ = (shift_cli_,)
       self.__doc__ = self.__call__.__doc__

       self.parameters={'vis':None, 'field':None, 'shiftval':None, 'nrows':None,  'async':None}


    def result(self, key=None):
	    #### here we will scan the task-ids in __async__
	    #### and add any that have completed...
	    if key is not None and self.__async__.has_key(key) and self.__async__[key] is not None:
	       ret = tm.retrieve(self.__async__[key])
	       if ret['state'] == "done" :
	          self.__async__[key] = None
	       elif ret['state'] == 'crashed' :
		  self.__async__[key] = None
	       return ret
	    return None


    def __call__(self, vis=None, field=None, shiftval=None, nrows=None,  async=None):

        """Shift a Measurement Set to different location.

	vis -- Name of input visibility file
		default: none; example: vis='ngc5921.ms'
	field -- Select fields in mosaic. Use field id(s) or field name(s).
		['go listobs' to obtain the list id's or names]
		default: ''=all fields
		If field string is a non-negative integer, it is assumed to
		be a field index otherwise, it is assumed to be a
		field name
		field='0~2'; field ids 0,1,2
		field='0,4,5~7'; field ids 0,4,5,6,7
		field='3C286,3C295'; field named 3C286 and 3C295
		field = '3,4C*'; field id 3, all names starting with 4C
	shift -- ra, dec shift
		default= '0.0arcsec';
		example: shiftval=['0.5arcsec,'0.5arcsec'] or
		shiftval=['1arcmin', '1arcmin']
		shiftval = '1arcsec' is equivalent to ['1arcsec','1arcsec']
	nrows -- Select the number of rows to process in each loop.
		Controls the number of data rows to read into RAM at a time.
		If the value is too large the process will fail.
		default = 1024

        """
	if not hasattr(self, "__globals__") or self.__globals__ == None :
           self.__globals__=sys._getframe(len(inspect.stack())-1).f_globals
        self.__globals__['__last_task'] = 'shift'
        self.__globals__['taskname'] = 'shift'
        ###
        self.__globals__['update_params'](func=self.__globals__['taskname'],printtext=False,ipython_globals=self.__globals__)
        ###
        ###
        #Handle globals or user over-ride of arguments
        #
	function_signature_defaults=dict(zip(self.__call__.func_code.co_varnames,self.__call__.func_defaults))
	useLocalDefaults = False

        for item in function_signature_defaults.iteritems():
                key,val = item
                keyVal = eval(key)
                if (keyVal == None):
                        #user hasn't set it - use global/default
                        pass
                else:
                        #user has set it - use over-ride
			if (key != 'self') :
			   useLocalDefaults = True

	myparams = {}
	if useLocalDefaults :
	   for item in function_signature_defaults.iteritems():
	       key,val = item
	       keyVal = eval(key)
	       exec('myparams[key] = keyVal')
	       if (keyVal == None):
	           exec('myparams[key] = '+ key + ' = self.itsdefault(key)')
		   keyVal = eval(key)
		   if(type(keyVal) == dict) :
                      if len(keyVal) > 0 :
		         exec('myparams[key] = ' + key + ' = keyVal[len(keyVal)-1][\'value\']')
		      else :
		         exec('myparams[key] = ' + key + ' = {}')

	else :
            async = self.parameters['async']
            myparams['vis'] = vis = self.parameters['vis']
            myparams['field'] = field = self.parameters['field']
            myparams['shiftval'] = shiftval = self.parameters['shiftval']
            myparams['nrows'] = nrows = self.parameters['nrows']

        if type(shiftval)==float: shiftval=[shiftval]

	result = None

#
#    The following is work around to avoid a bug with current python translation
#
        mytmp = {}

        mytmp['vis'] = vis
        mytmp['field'] = field
        if type(shiftval) == str :
           mytmp['shiftval'] = casac.qa.quantity(shiftval)
        else :
           mytmp['shiftval'] = shiftval
        mytmp['nrows'] = nrows
        pathname="file:///home/stephen/casa_tasks/"
        trec = casac.cu.torecord(pathname+'shift.xml')

        casalog.origin('shift')
        if not trec.has_key('shift') or not casac.cu.verify(mytmp, trec['shift']) :
	    return False

	try :
          if async :
	    count = 0
	    keybase =  time.strftime("%y%m%d.%H%M%S")
	    key = keybase + "_" + str(count)
	    while self.__async__.has_key(key) :
	       count += 1
	       key = keybase + "_" + str(count)
            result = tm.execute('shift', vis, field, shiftval, nrows)
	    print "Use: "
	    print "      tm.retrieve(return_value) # to retrieve the status"
	    print 
	    self.rkey = key
	    self.__async__[key] = result
          else :
              tname = 'shift'
              spaces = ' '*(18-len(tname))
              casalog.post('')
              casalog.post('##########################################')
              casalog.post('##### Begin Task: ' + tname + spaces + ' #####')
              casalog.post('')
              result = shift(vis, field, shiftval, nrows)
              casalog.post('')
              casalog.post('##### End Task: ' + tname + '  ' + spaces + ' #####')
              casalog.post('##########################################')

          saveinputs = self.__globals__['saveinputs']
          saveinputs('shift', 'shift.last', myparams, self.__globals__)
	except Exception, instance:
          if(self.__globals__.has_key('__rethrow_casa_exceptions') and self.__globals__['__rethrow_casa_exceptions']) :
             raise Exception, instance
          else :
             print '**** Error **** ',instance

        gc.collect()
        return result
#
#
#
    def paramgui(self, useGlobals=True, ipython_globals=None):
        """
        Opens a parameter GUI for this task.  If useGlobals is true, then any relevant global parameter settings are used.
        """
        import paramgui
	if not hasattr(self, "__globals__") or self.__globals__ == None :
           self.__globals__=sys._getframe(len(inspect.stack())-1).f_globals

        if useGlobals:
	    if ipython_globals == None:
                myf=self.__globals__
            else:
                myf=ipython_globals

            paramgui.setGlobals(myf)
        else:
            paramgui.setGlobals({})

        paramgui.runTask('shift', myf['_ip'])
        paramgui.setGlobals({})

#
#
#
    def defaults(self, param=None, ipython_globals=None, paramvalue=None, subparam=None):
	if not hasattr(self, "__globals__") or self.__globals__ == None :
           self.__globals__=sys._getframe(len(inspect.stack())-1).f_globals
        if ipython_globals == None:
            myf=self.__globals__
        else:
            myf=ipython_globals

        a = odict()
        a['vis']  = ''
        a['field']  = ''
        a['shiftval']  = ['0.0arcsec', '0.0arcsec']
        a['nrows']  = 1024

        a['async']=False

### This function sets the default values but also will return the list of
### parameters or the default value of a given parameter
        if(param == None):
                myf['__set_default_parameters'](a)
        elif(param == 'paramkeys'):
                return a.keys()
        else:
            if(paramvalue==None and subparam==None):
               if(a.has_key(param)):
                  return a[param]
               else:
                  return self.itsdefault(param)
            else:
               retval=a[param]
               if(type(a[param])==dict):
                  for k in range(len(a[param])):
                     valornotval='value'
                     if(a[param][k].has_key('notvalue')):
                        valornotval='notvalue'
                     if((a[param][k][valornotval])==paramvalue):
                        retval=a[param][k].copy()
                        retval.pop(valornotval)
                        if(subparam != None):
                           if(retval.has_key(subparam)):
                              retval=retval[subparam]
                           else:
                              retval=self.itsdefault(subparam)
		     else:
                        retval=self.itsdefault(subparam)
               return retval


#
#
    def check_params(self, param=None, value=None, ipython_globals=None):
      if ipython_globals == None:
          myf=self.__globals__
      else:
          myf=ipython_globals

      if str(type(value)) != "<type 'instance'>" :
         value = myf['cu'].expandparam(param, value)
         if(type(value) == numpy.ndarray) :
            myf[param] = value.tolist()
         else :
            myf[param] = value
         value = myf['cu'].verifyparam({param:value})
      return value
#
#
    def description(self, key='shift', subkey=None):
        desc={'shift': 'Shift a Measurement Set to different location.',
               'vis': 'name of input visibility file',
               'field': 'Field Name',
               'shiftval': 'ra and dec shift. default unit arcsec',
               'nrows': 'Number of rows to process at a time.',

               'async': 'If true the taskname must be started using shift(...)'
              }

        if(desc.has_key(key)) :
           return desc[key]

    def itsdefault(self, paramname) :
        a = {}
        a['vis']  = ''
        a['field']  = ''
        a['shiftval']  = ['0.0arcsec', '0.0arcsec']
        a['nrows']  = 1024

        #a = sys._getframe(len(inspect.stack())-1).f_globals

        if a.has_key(paramname) :
	      return a[paramname]
shift_cli = shift_cli_()
