import re, socket
import AIPS

def make_disk_from_host(host, disk=server_disk, port=server_port):
	"""Return an AIPSDisk object that represents
	disk <disk> on <host>"""
	url = 'http://%s:%d' % (host, port)
	return AIPS.AIPSDisk(url, disk)

def disk_summary(disklist=None):
	if not disklist:
		disklist = AIPS.disks
	for disk in disklist:
		if not disk:
			# Entry 0 might be None.
			continue
		if disk.url:
			print '<remote> %s %d' % (disk.url, disk.disk)
		else:
			print '<local> %d' % (disk.disk)

def host_from_url(url):
	"""Return the hostname component of a url."""
	match = re.match('\w+://([^:/]*).*', url)
	if not match:
		raise ValueError, 'Could not determine host'
	else:
		assert len(match.groups(0)) == 1
		return match.groups(0)

def host_index(disklist, host, diskno=1):
	"""Return the index of disk <diskno> on <host> in <disklist>"""
	if not disklist:
		disklist = AIPS.disks
	host_fqdn = socket.getfqdn(host)
	for i in range(len(disklist)):
		if not disklist[i]:
			continue
		if disklist[i].url:
			remote_host = host_from_urls(disklist[i].url)
			remote_fqdn = socket.getfqdn(remote_host)
			if remote_fqdn == host_fqdn and disklist[i].disk == diskno:
				return i
	raise ValueError, 'Disk %d on %s not found.' % (diskno, host)

