from unit_utils import days2dhms

def read_table(uv, su_ver=0, nx_ver=0):
	source = {}
	if uv.table_highver('SU') > 0:
		su = uv.table('SU', su_ver)
		for row in su:
			source[row['id__no']] = row['source'].strip()
	
	scan_list = []
	nx = uv.table('NX', nx_ver)
	for row in nx:
		scan = {}
		if source:
			scan['source'] = source[row['source_id']]
		scan['source_id'] = row['source_id']
		mid_point = row['time']
		length = row['time_interval']
		scan['start_time'] = days2dhms(mid_point - length/2)
		scan['end_time'] = days2dhms(mid_point + length/2)
		scan_list.append(scan)
	return scan_list

class scaninfo:
	def __init__(self, uv):
		self.scan_list = read_table(uv)
	def __getitem__(self, i):
		if i > len(self.scan_list) or i <= 0:
			raise IndexError
		return self.scan_list[i-1]
	def __len__(self):
		return len(self.scan_list)
	def scan_list(self):
		return self.scan_list
	def scantime(self, i):
		return self.scan_list[i]['start_time'] + self.scan_list[i]['end_time']

