#!/usr/bin/env ParselTongue

import AIPS
from AIPSData import AIPSImage, AIPSUVData
from Wizardry.AIPSData import AIPSUVData as WizAIPSUVData
import aips_data_atts

AIPS.userno = 502

im = AIPSImage('CC_POS', 'ICL001', 1, 1)
uv1 = AIPSUVData('HSA', 'UVDATA', 1, 1)
uv2 = AIPSUVData('J0750+1823', 'SPLIT', 1, 1)
uv1w = WizAIPSUVData(uv1)
uv2w = WizAIPSUVData(uv2)

for funcname in dir(aips_data_atts):
	if funcname.startswith('_'):
		continue
	if funcname.startswith('wiz'):
		data = uv1w, uv2w
	else:
		data = im, uv1, uv2, uv1w, uv2w
	func = getattr(aips_data_atts, funcname)
	for dataset in data:
		try:
			print '+ %s(%s): %s' % (funcname, dataset, str(func(dataset)))
		except:
			#print '%s did not work on %s(%s)' % (funcname, dataset.__class__.name, dataset.name)
			print '- %s did not work on %s' % (funcname, dataset)

