import sys, pyfits

current_labels = ['UU--SIN', 'VV--SIN', 'WW--SIN']
desired_labels = ['UU---SIN', 'VV---SIN', 'WW---SIN']

if len(sys.argv) != 2:
	print >> sys.stderr, 'Usage: %s fitsfile' % sys.argv[0]
	sys.exit(1)
infile = sys.argv[1]

inf = pyfits.open(infile, mode='update')
uv_table = False
for i in range(1, len(inf)):
	if inf[i].name == 'UV_DATA':
		uv_table = inf[i]
		break
if not uv_table:
	print >> sys.stderr, 'No UV_DATA table!'
	sys.exit(2)
modified = False
for i in range(len(current_labels)):
	old_label = current_labels[i]
	new_label = desired_labels[i]
	for key, value in uv_table.header.items():
		if value == old_label:
			uv_table.header[key] = new_label
			modified = True
if modified:
	print infile, 'modified'
inf.flush()
inf.close()
