#!/usr/bin/env python

# List the sources in a FITS-IDI file
# Stephen Bourke
# March 2009

import sys, pyfits

if len(sys.argv) != 2:
	print >> sys.stderr, 'Usage: %s fitsfile' % sys.argv[0]
	sys.exit(1)
infile = sys.argv[1]

inf = pyfits.open(infile)
arr_table = False
for i in range(1, len(inf)):
	if inf[i].name == 'ARRAY_GEOMETRY':
		arr_table = inf[i]
		break
if not arr_table:
	print >> sys.stderr, 'No SOURCE table!'
	sys.exit(2)

arr_index = False
for key, value in arr_table.header.items():
	if value == 'STABXYZ' and key.startswith('TTYPE'):
		arr_index = int(key[len('TTYPE'):]) - 1
		break

if not arr_index:
	print >> sys.stderr, "Couldn't find STABXYZ field in data!"
	sys.exit(2)

for record in arr_table.data:
	print record.field(arr_index)
