#!/usr/bin/env python

# List the sources in a FITS-IDI file
# Stephen Bourke
# March 2009

import sys, pyfits

if len(sys.argv) != 2:
	print >> sys.stderr, 'Usage: %s fitsfile' % sys.argv[0]
	sys.exit(1)
infile = sys.argv[1]

inf = pyfits.open(infile)
su_table = False
for i in range(1, len(inf)):
	if inf[i].name == 'SOURCE':
		su_table = inf[i]
		break
if not su_table:
	print >> sys.stderr, 'No SOURCE table!'
	sys.exit(2)

su_index = False
for key, value in su_table.header.items():
	if value == 'SOURCE' and key.startswith('TTYPE'):
		su_index = int(key[len('TTYPE'):]) - 1
		break

if not su_index:
	print >> sys.stderr, "Couldn't find SOURCE field in data!"
	sys.exit(2)

for record in su_table.data:
	print record.field(su_index)
