import AIPSLite

#AIPSLite.get_aips('/tmp', version='31DEC09')
#AIPSLite.quick_start()
AIPSLite.init_environ()
AIPSLite.make_da00('/tmp/da00')
AIPSLite.make_disk('/ibex/home/stephen/aips-data/LOCALHOST_1')

import AIPS
from AIPSTask import AIPSTask
from AIPSData import AIPSUVData

AIPS.userno = 9002
uv = AIPSUVData('20050113', 'C BAND', 1, 1)

xx = []
yy = []
zz = []
diam = []
an = uv.table('AN', 0)
for row in an:
	if not row.anname.endswith('OUT'):
		x, y, z = row.stabxyz
		xx.append(x)
		yy.append(y)
		zz.append(z)
		diam.append(25.0)

sm.open('T1.ms')
posvla = me.observatory('vla')
sm.setconfig(telescopename='VLA', x=xx, y=yy, z=zz, dishdiameter=diam,  
             mount='alt-az', antname='VLA', coordsystem='local',
             referencelocation=posvla)
#sm.setknownconfig('ATCA6.0A')
sm.setspwindow(spwname='CBand', freq='5GHz', deltafreq='50MHz',  
               freqresolution='50MHz', nchannels=1, stokes='RR RL LR LL')


sm.close()
