# Copyright (C) 2009
# The MeqTree Foundation & 
# JIVE (Joint Institute for VLBI in Europe)
# P.O.Box 2, 7990 AA Dwingeloo, The Netherlands
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>,
# or write to the Free Software Foundation, Inc., 
# 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

EVN = ['EB','JB','MC','NT','ON','SG','TR','UR','WB']
EEVN = ['EB','CM','JB2','MC','ON','TR','WB']
MERLIN6 = ['CM', 'JB2', 'DA', 'DE', 'KN', 'TA']
MERLIN7 = ['CM', 'JB2', 'JB', 'DA', 'DE', 'KN','TA']
VLBA = ['BR', 'FD','HN','KP','LA','MK','NL','OV','PT','SC']
HSA = ['AR','EB','GB', 'Y'] + VLBA
GLOBAL = EVN + VLBA
GMVA = ['EB','ON','MH','PV','NL','FD','LA','KP','PT','OV','BR','MK'] # PB?

VLA_A = ['YN8','YN16','YN24','YN32','YN40','YN48','YN56','YN64','YN72',
         'YE8','YE16','YE24','YE32','YE40','YE48','YE56','YE64','YE72',
         'YW8','YW16','YW24','YW32','YW40','YW48','YW56','YW64','YW72']
VLA_ANB = ['YN8','YN16','YN24','YN32','YN40','YN48','YN56','YN64','YN72',
           'YE4','YE8','YE12','YE16','YE20','YE24','YE28','YE32','YE36',
           'YW4','YW8','YW12','YW16','YW20','YW24','YW28','YW32','YW36']
VLA_B = ['YN4','YN8','YN12','YN16','YN20','YN24','YN28','YN32','YN36',
         'YE4','YE8','YE12','YE16','YE20','YE24','YE28','YE32','YE36',
         'YW4','YW8','YW12','YW16','YW20','YW24','YW28','YW32','YW36']
VLA_BNC = ['YN4','YN8','YN12','YN16','YN20','YN24','YN28','YN32','YN36',
           'YE2','YE4','YE6','YE8','YE10','YE12','YE14','YE16','YE18',
           'YW2','YW4','YW6','YW8','YW10','YW12','YW14','YW16','YW18']
VLA_C = ['YN2','YN4','YN6','YN8','YN10','YN12','YN14','YN16','YN18',
         'YE2','YE4','YE6','YE8','YE10','YE12','YE14','YE16','YE18',
         'YW2','YW4','YW6','YW8','YW10','YW12','YW14','YW16','YW18']
VLA_CND = ['YN2','YN4','YN6','YN8','YN10','YN12','YN14','YN16','YN18',
           'YE1','YE2','YE3','YE4','YE5','YE6','YE7','YE8','YE9',
           'YW1','YW2','YW3','YW4','YW5','YW6','YW7','YW8','YW9']
VLA_D = ['YN1','YN2','YN3','YN4','YN5','YN6','YN7','YN8','YN9',
         'YE1','YE2','YE3','YE4','YE5','YE6','YE7','YE8','YE9',
         'YW1','YW2','YW3','YW4','YW5','YW6','YW7','YW8','YW9']

WSRT = ['WRT0','WRT1','WRT2','WRT3','WRT4',
        'WRT5','WRT6','WRT7','WRT8','WRT9',
        'WRTA','WRTB','WRTC','WRTD']
WSRT10 = ['WRT0','WRT1','WRT2','WRT3','WRT4',
          'WRT5','WRT6','WRT7','WRT8','WRT9']

GMRT = ['GMRT:C00:01', 'GMRT:C01:02', 'GMRT:C02:03', 'GMRT:C03:04',
        'GMRT:C04:05', 'GMRT:C05:06', 'GMRT:C06:07', 'GMRT:C08:08',
        'GMRT:C09:09', 'GMRT:C10:10', 'GMRT:C11:11', 'GMRT:C12:12',
        'GMRT:C13:13', 'GMRT:C14:14', 'GMRT:E02:15', 'GMRT:E03:16',
        'GMRT:E04:17', 'GMRT:E05:18', 'GMRT:E06:19', 'GMRT:S01:20',
        'GMRT:S02:21', 'GMRT:S03:22', 'GMRT:S04:23', 'GMRT:S06:24',
        'GMRT:W01:25', 'GMRT:W02:26', 'GMRT:W03:27', 'GMRT:W04:28',
        'GMRT:W05:29', 'GMRT:W06:30', 'GMRT:C07:31', 'GMRT:S05:32']

LOFAR_CORE_LBA = ['CS001LBA', 'CS002LBA', 'CS003LBA', 'CS004LBA',
                  'CS005LBA', 'CS006LBA', 'CS007LBA', 'CS011LBA',
                  'CS013LBA', 'CS017LBA', 'CS021LBA', 'CS024LBA',
                  'CS026LBA', 'CS028LBA', 'CS030LBA', 'CS031LBA',
                  'CS032LBA', 'CS101LBA', 'CS103LBA', 'CS201LBA',
                  'CS301LBA', 'CS302LBA', 'CS401LBA', 'CS501LBA']
LOFAR_CORE_HBA = ['CS001HBA0', 'CS001HBA1', 'CS011HBA0', 'CS011HBA1',
                      'CS013HBA0', 'CS013HBA1', 'CS017HBA0', 'CS017HBA1',
                      'CS021HBA0', 'CS021HBA1', 'CS024HBA0', 'CS024HBA1',
                      'CS026HBA0', 'CS026HBA1', 'CS028HBA0', 'CS028HBA1',
                      'CS030HBA0', 'CS030HBA1', 'CS031HBA0', 'CS031HBA1',
                      'CS032HBA0', 'CS032HBA1', 'CS101HBA0', 'CS101HBA1',
                      'CS103HBA0', 'CS103HBA1', 'CS201HBA0', 'CS201HBA1',
                      'CS301HBA0', 'CS301HBA1', 'CS302HBA0', 'CS302HBA1',
                      'CS401HBA0', 'CS401HBA1', 'CS501HBA0', 'CS501HBA1']
LOFAR_REMOTE_LBA = ['RS106LBA', 'RS205LBA', 'RS208LBA', 'RS306LBA',
                    'RS307LBA', 'RS406LBA', 'RS503LBA', 'RS508LBA',
                    'RS509LBA']
LOFAR_REMOTE_HBA = ['RS106HBA', 'RS205HBA', 'RS208HBA', 'RS306HBA',
                    'RS307HBA', 'RS406HBA', 'RS503HBA', 'RS508HBA',
                    'RS509HBA']
LOFAR_INTERNATIONAL_LBA = ['DE601LBA', 'DE602LBA', 'DE603LBA', 'DE604LBA',
                           'DE605LBA', 'FR606LBA', 'SE607LBA', 'UK608LBA']
LOFAR_INTERNATIONAL_HBA = ['DE601HBA', 'DE602HBA', 'DE603HBA', 'DE604HBA',
                           'DE605HBA', 'FR606HBA', 'SE607HBA', 'UK608HBA']

LOFAR_NL_LBA = LOFAR_CORE_LBA + LOFAR_REMOTE_LBA
LOFAR_NL_HBA = LOFAR_CORE_HBA + LOFAR_REMOTE_HBA
ELOFAR_LBA = LOFAR_CORE_LBA + LOFAR_REMOTE_LBA + LOFAR_INTERNATIONAL_LBA
ELOFAR_HBA = LOFAR_CORE_HBA + LOFAR_REMOTE_HBA + LOFAR_INTERNATIONAL_HBA

MWA512 = ['MWA512_%03d' % (i+1) for i in range(512)]
MWA32T = ['MWA32T_%03d' % (i+1) for i in range(32)]

KAT7 = ['KAT7:%d' % (i+1) for i in range(7)]

RS208_LBA_INNER = ['LBA_INNER:%02d' % (i+1) for i in range(48)]
RS208_LBA_OUTER = ['LBA_OUTER:%02d' % (i+1) for i in range(48)]
RS208_LBA_SPARSE0 = ['LBA_SPARSE0:%02d' % (i+1) for i in range(48)]
RS208_LBA_SPARSE1 = ['LBA_SPARSE1:%02d' % (i+1) for i in range(48)]
RS208_LBA_X = ['LBA_X:%02d' % (i+1) for i in range(96)]
RS208_LBA_Y = ['LBA_Y:%02d' % (i+1) for i in range(96)]
RS208_HBA = ['HBA:%02d' % (i+1) for i in range(48)]

VLAA = VLA_A; VLAB = VLA_B; VLAC = VLA_C; VLAD = VLA_D # backwards compatibility

def defined_arrays():
    """Return a list of the predefined arrays."""
    array_list = []
    for arr_name in globals():
        if not arr_name.startswith('_') and arr_name.isupper():
            array_list.append(arr_name)
    return array_list

def array_ants(arr_str):
    try:
        return eval(arr_str)
    except SyntaxError:
        raise ValueError, 'Array description not valid'
