#!/usr/bin/env ParselTongue

# Create a text file of antenna parameters from an aips dataset.
# Stephen Bourke, JIVE.
# Sept, 2009.
#
# Version: 20090930

import AIPS
from AIPSData import AIPSUVData
import sys

AIPS.userno = 401
uv = AIPSUVData('METH G78', 'UVDATA', 1, 1)
mount = 'ALT-AZ'
dish_size = 25

ant = uv.table('AN', 0)
arrx = ant.keywords['ARRAYX']
arry = ant.keywords['ARRAYY']
arrz = ant.keywords['ARRAYZ']
if arrx or arry or arrz:
	# TODO: Handle projection of coordinates.
	print >> sys.stderr, 'WARNING: Array is not earth centered.'
	print >> sys.stderr, 'Antenna table will probably be incorrect.'
station = ant.keywords['ARRNAM'].strip()
for row in ant:
	x, y, z = row['stabxyz']
	print row['anname'].strip(), station, x, y, z, mount, dish_size
