#!/usr/bin/env python

"""Create a text output from a MS Antenna table."""

from pyrap.tables import table
import sys
from optparse import OptionParser

import warnings
warnings.filterwarnings('ignore', category=DeprecationWarning)

parser = OptionParser(usage='%prog [options] <infile> [outfile]',
    description=__doc__)
parser.add_option('-n', '--name', dest='name', help='Override name')
parser.add_option('-s', '--station', dest='station', help='Override station')
parser.add_option('-m', '--mount', dest='mount', help='Override mount type',
    type='choice', choices=('ALT-AZ', 'EQUATORIAL', 'SPACE-HALCA', 'X-Y'))
parser.add_option('-d', '--diameter', dest='dish_diameter', help='Override dish size')
options, iofiles = parser.parse_args()

if not iofiles:
    print >> sys.stderr, 'No MS table specified'
    parser.print_usage()
    sys.exit()
msname = iofiles[0]
try:
    outf = open(iofiles[1], 'w')
except IndexError:
    outf = sys.stdout
if len(iofiles) > 2:
    print >> sys.stderr, 'Too many arguments'
    parser.print_usage()
    sys.exit()

ant_table = table(msname, ack=False)
for row in ant_table:
    # Create the following variables in the current scope
    for var in ['name', 'station', 'mount', 'dish_diameter']:
        if eval('options.' + var) is not None:
            # Override with command line value
            exec('%s = options.%s' % (var, var))
        else:
            exec('%s = row["%s"]' % (var, var.upper()))
    x, y, z = row['POSITION']
    print >> outf, name, station, x, y, z, mount, dish_diameter
    
    if not (row['OFFSET'] == [0,0,0]).all():
        print >> sys.stderr, 'Warning offset on %s not 0' % row['NAME']
