#!/usr/bin/python

import numpy
import sys

def get_positions(filename, array_name):
	# Messy way to get dipole postions from old lofar conf file
	inf = open(filename)
	lines = inf.readlines()
	line_start = -1
	for i in range(len(lines)):
		if lines[i].strip() == array_name:
			line_start = i
			break
	if line_start == -1:
		raise ValueError, '%s not found' % array_name
	
	name = lines[line_start].strip()
	offset = numpy.array([float(i) for i in lines[line_start+1].split()[2:-1]])
	shape = [int(lines[line_start+2].split()[i]) for i in [0,2,4]]
	pos = []
	for line in lines[line_start+3:line_start+3+shape[0]]:
		pos += [float(i) for i in line.split()]
	
	pos = numpy.array(pos).reshape(shape)
	
	return {'array_name': name, 'array_pos': offset, 'ant_pos': pos}

if __name__ == '__main__':
	if len(sys.argv) != 2:
		print >> sys.stderr, 'Usage: %s <name>' % sys.argv[0]
		sys.exit()
	print get_positions('AntennaArraysRS208.conf', sys.argv[1])
