#!/usr/bin/env python

import re
import sys

ANTENNAS = ['CM', 'EB', 'JB2', 'LA']

comment_line = re.compile('^!')
name_line = re.compile("\s*DBCODE=\s*(\w+)\s*DBNAME=([\w-]+)\s*AXISTYPE='(\w+)'\s*AXISOFF=\s*(-?\d+\.\d+)\s*")
xyz_line = re.compile('\s*X=\s*(-?\d+\.\d+)\s*Y=\s*(-?\d+\.\d+)\s*Z=\s*(-?\d+\.\d+)\s*')
end_block = re.compile('^/')

ant_list = []
have_name = False
have_xyz = False
for line in sys.stdin:
	if comment_line.match(line):
		continue
	name_match = name_line.match(line)
	if name_match:
		have_name = True
		code, name, mount, offset = name_match.groups()
		if mount == 'alta' or mount == 'altz':
			mount = 'ALT-AZ'
		elif mount == 'equa':
			mount = 'EQUATORIAL'
		elif mount == 'spac':
			mount = 'SPACE-HALCA'
		elif mount == 'xyEW' or mount == 'xyNS':
			mount = 'X-Y'
		else:
			print >> sys.stderr, 'Unknown mount', mount
	xyz_match = xyz_line.match(line)
	if xyz_match:
		have_xyz = True
		x, y, z = [float(i) for i in xyz_match.groups()]
	if end_block.match(line):
		assert have_name and have_xyz
		have_name = False
		have_xyz = False
		if code in ANTENNAS:
			ant_list.append({'POSITION': [x,y,z], 'MOUNT': mount,
				'STATION': name, 'NAME': code})
print ant_list
print len(ant_list)
